xBookUtils.printDebugStatements = "off";

/*
Variables = Variables.extend({

    init: function() {
	// get definitions
	this.get_variable_definitions();
	
	var t = this;
	
	// replace in image src's (HTS formulas)
	$("img").each(function(){
	    var src = $(this).attr("src");
	    src = t.replace_values(src, "img");
	    $(this).attr("src", src);
	});
        
	// vars in queries are replaced separately
	
	// now replace in the whole manuscript, wrapping in spans this time
	//var html = $("#manuscript").html();
	//html = this.replace_values(html, "span");
	//$("#manuscript").html(html);
    }
});
*/

Figures = Figures.extend({
    process_media: function() {
        safe_log("process_media");
        return;
    }
});

/*
var Player = Player.extend({

    initialize: function() {
        safe_log("Player initialize");
        return;
    }
    
});
*/

var noopDSApi = {
    initializeClass : function(){
        var dfd = jQuery.Deferred();
        setTimeout(function(){
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },
    initializeUser: function(){
        var dfd = jQuery.Deferred();
        setTimeout(function(){
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();},
    loadClassData: function(){
	var dfd = jQuery.Deferred();
	setTimeout(function(){
	    dfd.resolve([]);
	}, Math.floor(100 + Math.random() * 500));
	return dfd.promise();},
    loadGlobalClassData: function(){
	var dfd = jQuery.Deferred();
	setTimeout(function(){
	    dfd.resolve(null);
	}, Math.floor(100 + Math.random() * 500));
	return dfd.promise();},
    setData: function(){},
    setGlobalData: function(){
	var dfd = jQuery.Deferred();
	setTimeout(function(){
	    dfd.resolve(null);
	}, Math.floor(100 + Math.random() * 500));
	return dfd.promise();},    
};



/* 
   This is the standard template you should add to your book JS file before 
   customizing.

   Uncomment any of the configuration options to change the default behavior (see 
   https://macmillanhighered.atlassian.net/wiki/display/MP/Player+Configuration+Options
   for descriptions of the options).

*/

/***********************************************
  REQUIRED: Set this to the DF book ID (Subtype)
 ***********************************************/
xBookUtils.bookID = "bsmtest2";

/* 
   The discipline is not required any more since we no longer use the HTML Quiz
   question delivery method.  You do not need to fill in these values.  This has
   been commented out and kept around for historical value only.
*/
/*
xBookUtils.discipline = {
    dev: 0,
    qa: 0,
    pr: 0,
    www: 0
}
*/

var Player_subtype = Player_manuscript_type.extend({
    
    //cfg_removeRawHtmlDivs: "on",

    //cfg_showAnswer: "on",
    //cfg_showAnswerAutoWrapThis: "off",
    
    //cfg_Box_moveTitle: "all",
    //cfg_Box_moveTitleExclude: "",

    //cfg_Figures_targetDefault: "_blank",
    //cfg_Figures_resizeDivWidth: "off",

    //cfg_Figures_autoHtml: "on",
    //cfg_LH_autoHtml: "on",

    //cfg_LH_externalTargetDefault: "_pop",
    //cfg_LH_internalTargetDefault: "_pop",
    //cfg_LH_ebookTargetDefault: "_pop",
    //cfg_LH_imageTargetDefault: "_blank",

    //cfg_LH_useOpenContent: "on",
    //cfg_LH_useLinksFile: "on",
    
    //cfg_Glossary_hoverTerms: "on",
    //cfg_Glossary_useStickyDiv: "on",
    //cfg_Glossary_hoverTermsNoClick: "",


    ds : {
	isInitialized : false,
	
	api : ( typeof ((((window.parent || {}).PX || {}).API || {}).DataService) != "undefined") ? window.parent.PX.API.DataService : noopDSApi,

	userData: {},

	generateDataRecord: function(datasetID, key, value, loadOnUserInit, loadOnClassInit, loadOnSchoolInit){
	    
	    //safe_log("generateDataRecord");
	    //safe_log(value);

	    var course_id = "1001";
	    var user_id = "5001";
	    
	    if (xBookUtils.inPX()) {
		course_id = parent.PxPage.Context.Course.EntityId;
		user_id = parent.PxPage.Context.User.CurrentUserId;
	    }
	    
            var r = {
                CourseId: course_id,
                InstitutionId: null,
                UserId: user_id,
                Key: key,
		Value: value,  // this is string now, no need to stringify
                DataSetId: datasetID,
                LoadOnUserInit: loadOnUserInit,
                LoadOnClassInit: loadOnClassInit,
                LoadOnSchoolInit: loadOnSchoolInit
            };

	    safe_log("The object we are storing is ...");
	    safe_log(r);
	    
            return r;
	    
	} // end generateDataRecord
    },

    
    initialize_sections: function() {
	
	// Do not delete this
	this._super();
	
        // Add custom JS code below. Anything that needs to be done before
	// the page displays should be done here.


	
	
    }, // end initialize_sections
    
    /* 
       You will most likely not make any changes to the initialize method.
    */
    initialize: function(id) {

        //return;
        
	// Do not delete this
	this._super(id);

	// Don't delete these unless you know exactly what you are doing :-)
	this.xrefs = new XRefs_manuscript_subtype();
	this.glossary = new Glossary_manuscript_subtype();
        //this.figures = new Figures_manuscript_subtype();
	this.tables = new Tables_manuscript_subtype();

        $("[data-type='section']").css('display', 'block');

        
    }, // end initialize
    
    initialize2: function() {
	
	// Do not delete this
        this._super();

	// You will most likely not want to delete this
	var link_handler = new LinkHandler();


$('video').each(function() {
   var $this = $(this);
   var path = $this.attr('data-path');
   var source = $this.attr('data-source');

   var url = (source === "dev") ? "http://digfir-published.macmillanusa.com/" + path : "http://digitalfirst.bfwpub.com/" + path;

   $this.attr('src', url);
   $this[0].load();

});


/*
try {
    safe_log("top");
    safe_log(top);
    safe_log("top.PX");
    safe_log(top.PX);
    safe_log("top.LearningCurve");
    safe_log(top.LearningCurve);
    safe_log("top.LearningCurve.displayContent");
    safe_log(top.LearningCurve.displayContent);
    safe_log("pxPage.routes");
    safe_log(top.PxPage.Routes);
    safe_log("top.PX.DataManager");
    safe_log(top.PX.DataManager);
    safe_log(top.PX.DataManager.GetItemById + "");
}
catch(err) {
}
*/

$("#testing_lc").click(function() {

  //safe_log(top.LearningCurve.displayContent);
  //debugger;
  //top.LearningCurve.displayContent("bsi__92370D3A__02A0__4BF6__9CB7__C89DC81092A3");
  //top.LearningCurve.displayContent("myers11e_2_1_2");

  top.PX.DataManager.GetItemById("testing").then(function(item) {
          console.log(item);	
          console.log("itemID = " + item.Id);
          console.log("url = " + item.Url);    
  });

/*

   $.post(top.PxPage.Routes.LearningCurve_GetEbookInfo, {
                        itemId: "bsi__92370D3A__02A0__4BF6__9CB7__C89DC81092A3"
                    }, function(e) {
                        console.log("return value from LearningCurve_GetEbookInfo");
                        console.log(e);
                    });
*/

/*
   $.post(top.PxPage.Routes.LearningCurve_GetEbookInfo, {
                        itemId: "bsi__92370D3A__02A0__4BF6__9CB7__C89DC81092A3"
                    }, function(e) {
                       console.log(e);

                       var n = top.PxPage.Routes.display_content + "?id=" + e.Id + "&mode=4&includeNavigation=false&includeToc=false&reaOnly=true&includeDiscussion=false";


                        console.log(n);

console.log("post");
console.log($.post);

  $.post(n, {}, function(t) {
    console.log(t);
  });
*/

                        /*
                        e && "Success" === e.Status ? (i = e.Id && "" != e.Id ? e.Id : i, t.fn.displayContentInDialog(i, e.Title)) : (PxPage.Loaded("#fne-window"), e.ProductType && "LearningCurve" !== e.ProductType && t.fn.displayMessageInDialog("", "The specified content item could not be found in this course"))
                        */
                    //});


});


	// Add custom JS code below. Anything that can be done after the
	// page displays should be done here.

        // Don't need these any more, DF is now passing the 'char' through to the HTML
	//$("#psbe4e-ch01-untab-001 tbody tr td:nth-child(3)").attr("char", " x ");
	//$("#psbe4e-ch01-untab-001 tbody tr td:nth-child(4)").attr("char", " → ");

	
        // get main browser URL
        var browser_url = window.location;
        //safe_log(browser_url);

	if (player.ARGA_running && xBookUtils.getChapter() == 36) {
	    
	    $('#initializeUser').click(function() {
		attemptInitUser();
	    });
	    $('#setData').click(function() {
		attemptSetData();
	    });
	    $('#loadUserData').click(function() {
		attemptLoadUserData();
	    });
	    
	}

	
	// New feature to allow table columns to align content by character.
	// This should always come after any custom JS code you add.  If you
	// do not have any tables that need to be aligned by character then you
	// can comment this out.
	this.tables.align_columns();

        var $test_p = $("#vid_test");
        if ($test_p.length > 0) {
            var myPlayer,
                playerHTML,
                playerData = {
                    'accountId': '1500315202001',
                    'playerId': 'B1AhVYg4l',
                    // 'videoId': '5402064911001'
                    //'videoId': '2649752887001',
                    'videoId': '5248329283001'
                    //'videoId': '5387813537001',
                    //'videoId': '5343414080001'
                };
            
            playerHTML = '<video id=\"vidPlayerID\" data-video-id=\"' + playerData.videoId + '\"  data-account=\"' + playerData.accountId + '\" data-player=\"' + playerData.playerId + '\" data-embed=\"default\" class=\"video-js\" controls></video>';
            // inject the player code into the DOM
            document.getElementById('vid_test').innerHTML = playerHTML;
            // instantiate player
            bc(document.getElementById('vidPlayerID'));
            videojs('vidPlayerID').ready(function(){
                myPlayer = this;
            });
        }

/*
        var $test_p2 = $("#vid_test2");
        if ($test_p2) {
            var myPlayer,
                playerHTML,
                playerData = {
                    'accountId': '1500315202001',
                    'playerId': 'B1AhVYg4l',
                    //'videoId': '5248329283001'
                    'videoId': '5387813537001',
                };
            
            playerHTML = '<video id=\"vidPlayerID\" data-video-id=\"' + playerData.videoId + '\"  data-account=\"' + playerData.accountId + '\" data-player=\"' + playerData.playerId + '\" data-embed=\"default\" class=\"video-js\" controls></video>';
            // inject the player code into the DOM
            document.getElementById('vid_test2').innerHTML = playerHTML;
            // instantiate player
            bc(document.getElementById('vidPlayerID'));
            videojs('vidPlayerID').ready(function(){
                myPlayer = this;
            });
        }
*/  
      
    } // end initialize2


    
}); // end Player_subtype


// Do not delete this
player = new Player_subtype();


function attemptInitUser() {
    safe_log("Attempting to initializeUser...");
    player.ds.api.initializeUser("test").then(
	// success
	function(a) {
	    if (a !== null && a!== undefined) {
		safe_log("initializeUser successful, returned the following object:");
		safe_log(a);
	    }
	    else {
		safe_log("initializeUser successful but object is not defined");
	    }
	},
	// failure
	function(b) {
	    safe_log("initializeUser unsuccessful, returned the following object:");
	    safe_log(b);
	}
    );
}

function attemptSetData() {
    safe_log("Attempting to execute setData");
    var dataObject = {};
    dataObject.score = Math.floor((Math.random() * 1000) + 1);
    var record = player.ds.generateDataRecord("test", "scores", dataObject, "true", "true", "false");
    
    try {
	player.ds.api.setData([record]).then(
	    // success
	    function onResponse(data) {
		safe_log("setData successful");
	    },
	    // failure
	    function onError(fault) {
		safe_log("setData unsuccessful, returned error:" + fault);
	    }
	);
    }
    catch(err) {
	safe_log("Could not call setData: " + err.message);
    }
}

function attemptLoadUserData() {
    safe_log("Attempting to loadUserData");
    
    player.ds.api.loadUserData("test","scores").then(
	// success
	function(a) {
	    safe_log("loadUserData successful, returned the following object:");
	    safe_log(a);
	},
	// failure
	function(b) {
	    safe_log("loadUserData unsuccessful, returned the following object:");
	    safe_log(b);
	}
    );
}

/*
top.LearningCurve.displayContent = function(e) {

  console.log("Entering top.LearningCurve.displayContent");
  console.log(e);
t.fn.displayContent(e);

}
*/
