var Activity_manuscript = Activity.extend({

    submit_question: function(question_index) {

	if (!player.all_fields_answered()) {
	    safe_log("Cannot submit answer: missing fields");
	    return;
	}

	player.set_query_answer();

	$(".template_question").remove();
	$("[data-block_type='template_answer']").remove();

	this._super(question_index);

	if (player.question_completed()) {
	    $(".template_question").remove();
	    $("[data-block_type='template_answer']").remove();
	}
    },

    /*
    add_query: function(index, element) {
	this._super(index, element);

	safe_log("add_query");

	if (player.question_completed()) {
	    var query_text = $("[data-type='question']").find("textarea").val();
	    if (!xBookUtils.emptyValue(query_text)) {
		$("[data-type='question']").before("<p>" + query_text + "</p>");
	    }
	}
    },
    
    add_page_queries: function() {
	this._super();
	
	safe_log("add_page_queries");
	
	if (player.question_completed()) {
	    var query_text = $("[data-type='question']").find("textarea").val();
	    if (!xBookUtils.emptyValue(query_text)) {
		$("[data-type='question']").before("<p>add_page_queries: " + query_text + "</p>");
	    }
	}
    },
    
    add_question: function(index, element) {
	this._super(index, element);
	
	safe_log("add_question");
	
	if (player.question_completed()) {
	    var query_text = $("[data-type='question']").find("textarea").val();
	    if (!xBookUtils.emptyValue(query_text)) {
		$("[data-type='question']").before("<p>add_question: " + query_text + "</p>");
	    }
	}
    }
    */

    /*
    initialize: function() {
	this._super();

	safe_log("Activity.initialize");
	
	if (player.question_completed()) {
	    var query_text = $("[data-type='question']").find("textarea").val();
	    if (!xBookUtils.emptyValue(query_text)) {
		$("[data-type='question']").before("<p>add_question: " + query_text + "</p>");
	    }
	}
    }
    */
    
});


/*
function Initialize_ARGA_Session_Callback() {

    safe_log("Initialize_ARGA_Session_Callback");
    
    player.initialize2();

    safe_log(player.question_completed());
    
    if (player.question_completed()) {
	var $textarea = $("#query_answer_0");
	safe_log($textarea.attr('id'));
	var query_text = $textarea.val();
	safe_log("query_text: " + query_text);
	if (!xBookUtils.emptyValue(query_text)) {
	    $("[data-type='question']").before("<p>" + query_text + "</p>");
	}
    }
}
*/



var Player_subtype_bruce = Player_subtype.extend({

    show_section: function(section_to_show) {
	this._super(section_to_show);
	
	if (this.question_completed()) {
	    $("[data-type='question']").before("<p class='student_answer'>" + player.activity.queries[0].user_answer + "</p>");
	    $('[data-type="question"] textarea').css("display", "none");
	}
    },
    
    initialize: function(id) {
	
	// Do not delete this
	this._super(id);

	player.activity = new Activity_manuscript();
	
    }, // end initialize
    
    initialize2: function() {
	
        this._super();

	safe_log("initialize2");
	//safe_log(player.activity);
	
	
	if (!this.question_completed()) {

	    //$('[data-type="question"] textarea').css("display", "none");
	    
	    this.update_answer();
	    
	    $(".template_question").children("textarea").bind('input propertychange', function() {
		player.update_answer();
		player.set_query_answer();
	    });
	    
	    $(".template_question").children("textarea").focusout(function() {
		player.resize_textarea($(this), "small");
	    });
	    
	    $(".template_question").children("textarea").focusin(function() {
		player.resize_textarea($(this), "big");
	    });
	    
	    $("[data-block_type='template_answer']").delegate("[data-field_num]", "click", function(event) {  
		safe_log("caught click");
		var $this = $(this);
		var num = $this.attr('data-field_num');
		$("[data-q-num='" + num + "']").focus();
	    });
	}
	else {
	    $(".template_question").remove();
	    $("[data-block_type='template_answer']").remove();
	    //$("[data-type='question']").before("<p>" + player.activity.queries[0].user_answer + "</p>");
	}
	
    },

    question_completed: function() {

	// If we aren't in ARGA mode then we can't determine if question has been
	// completed or not.
	if (!player.ARGA_running) {
	    safe_log("question_completed: not in ARGA mode, returning false")
	    return false;
	}

	var grade = Get_ARGA_Grade();
	if (grade != "" && grade != null && grade >= 0) {
	    return true;
	}
	return false;
	
    },
    
    toggle_submit_button: function(status) {
	if (status === "on") {
	    $("[data-type='question'] input").css("display", "initial");
	}
	else {
	    $("[data-type='question'] input").css("display", "none");
	}
    },

    resize_textarea: function($jQueryObj, size) {
	if (size === "big") {
	    $jQueryObj.css("width", "350px");
	    $jQueryObj.css("height", "8em");
	    $jQueryObj.css("position", "relative");
	}
	else {
	    $jQueryObj.css("width", "10em");
	    $jQueryObj.css("height", "1.5em");
	    $jQueryObj.css("position", "initial");
	}
    },
    
    all_fields_answered: function() {
	var $template = $(".template_question");
	var num_fields = $template.attr('data-num-fields');
	
	for (var i=1; i<= num_fields; i++) {
	    var q_num = "[data-q-num=" + i + "]";
	    var $field = $template.children(q_num);
	    if ($field.length < 1) {
		continue;
	    }
	    var tag = ($field[0].tagName).toLowerCase();
	    if (tag === "span") {
		continue;
	    }
	    var textarea_answer = $.trim($field.val());
	    if (xBookUtils.emptyValue(textarea_answer)) {
		return false;
	    }
	}
	return true;
    },

    // Add the answer to the official query textbox
    set_query_answer: function() {
	var answer = this.get_answer();
	
	answer = answer.replace(/<(\/)?[^>]+>/gi, '');
	$("#query_answer_0").val(answer);
    },

    // Returns a string containing the template text including all user input.  If
    // a field does not have an answer then it will be replaced with [NEEDS ANSWER].
    get_answer: function() {

	var answer = "";
	var $template = $(".template_question");
	var num_fields = $template.attr('data-num-fields');
	
	for (var i=1; i<= num_fields; i++) {
	    
	    var q_num = "[data-q-num=" + i + "]";
	    var $field = $(q_num);

	    if ($field.length < 1) {
		continue;
	    }

	    var tag = ($field[0].tagName).toLowerCase();
	    
	    if (tag === "span") {
		answer += $field.html();
	    }
	    else {
		var textarea_answer = $.trim($field.val());
		
		if (xBookUtils.emptyValue(textarea_answer)) {
		    answer += "<span data-field_num='" + i + "' class='needs_answer'>[NEEDS ANSWER]</span>";
		}
		else {
		    answer += "<span data-field_num='" + i + "'>" + textarea_answer + "</span>";
		}
	    }
	}
	
	return answer;
    },
    
    update_answer: function() {
	
	var answer = this.get_answer();
	
	$("[data-block_type='template_answer'] > p").html(answer);

	if (this.all_fields_answered()) {
	    this.toggle_submit_button("on");
	}
	else {
	    this.toggle_submit_button("off");
	}
    }
    
}); // end Player_subtype


player = new Player_subtype_bruce();


